/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.mospcommon.system.action;

import java.sql.SQLException;
import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.mospcommon.system.LaborAgreementManager;
import jp.mosp.mospcommon.system.dao.CmAgreementOverTimeDao;
import jp.mosp.mospcommon.system.dto.CmAgreementOverTimeDto;
import jp.mosp.mospcommon.system.vo.OverTimeAgreementCardVo;

/**
 * @author koike
 *
 */
public class OverTimeAgreementCardAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_OVER_TIME_AGREEMENT_CARD_SHOW	= "S2525";	// 表示(追加)
	private static final String	CMD_OVER_TIME_AGREEMENT_CARD_SELECT	= "S2526";	// 表示(選択)
	private static final String	CMD_OVER_TIME_AGREEMENT_CARD_INSERT	= "S2527";	// 登録
	private static final String	CMD_OVER_TIME_AGREEMENT_CARD_UPDATE	= "S2528";	// 更新
																				
	
	/**
	 * コンストラクタ
	 */
	public OverTimeAgreementCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの取得		
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_OVER_TIME_AGREEMENT_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_OVER_TIME_AGREEMENT_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_OVER_TIME_AGREEMENT_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_OVER_TIME_AGREEMENT_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new OverTimeAgreementCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmSystemAuth();
		OverTimeAgreementCardVo vo = (OverTimeAgreementCardVo)getVo();
		// 協定種類プルダウンリスト作成
		vo.aryPltAgreeType = part().mospcode().getAgreementTypeArray();
		// 限度基準プルダウンリスト作成
		vo.aryPltLimitCode = getLimitStandardArray();
		// 年月日
		// 開始年月日プルダウンリスト作成
		Date todayDate = DateUtil.getSystemDate();
		vo.aryPltYear = StringUtil.getYearArray(MospUtility.getYear(todayDate));
		vo.aryPltMonth = StringUtil.getMonthArray();
		vo.aryPltDay = StringUtil.getDayArray();
	}
	
	@Override
	protected void show() {
		OverTimeAgreementCardVo vo = (OverTimeAgreementCardVo)getVo();
		vo.setDefaultValues();
		// 初期値設定
		Date todayDate = DateUtil.getSystemDate();
		vo.setPltStartDateYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltStartDateMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		vo.setPltStartDateDay(String.valueOf(MospUtility.getDay(todayDate)));
		vo.setTxtOverTimeRate("125");
		vo.setTxtCautionMonthHour("60");
		vo.setTxtCautionMonthMin("0");
		vo.setTxtMonthlyOverTimeRate("150");
		vo.setTxtSubAcquireRate("125");
		vo.setTxtSubAcquireHolidayRate("125");
		vo.setTxtSubQuitRate("150");
		vo.setPltDeletFlag(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setMode(OverTimeAgreementCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		OverTimeAgreementCardVo vo = (OverTimeAgreementCardVo)getVo();
		CmAgreementOverTimeDao dao = new CmAgreementOverTimeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// データの取得
		CmAgreementOverTimeDto dto = dao.findForKey(Integer.parseInt(key1));
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(OverTimeAgreementCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		OverTimeAgreementCardVo vo = (OverTimeAgreementCardVo)getVo();
		vo.setParams(request);
		vo.setPltDeletFlag(String.valueOf(MospConst.DELETE_FLAG_OFF));
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		CmAgreementOverTimeDto dto = new CmAgreementOverTimeDto();
		// DAOの準備
		CmAgreementOverTimeDao dao = new CmAgreementOverTimeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		String max = dao.findForMax();
		if (StringUtil.isNull(max)) {
			max = "-1";
		}
		vo.setDtoFields(dto);
		dto.setOverTimeId(Integer.parseInt(max) + 1);
		// 重複チェック
		chkDuplicate(dao.findForKey(dto.getOverTimeId()));
		chkDuplicate(dao.findForStartDate(dto.getOverTimeCode(), dto.getStartDate()));
		// 限度基準コードの妥当性
		checkLimitStandard();
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		CmAgreementOverTimeDto retDto = dao.findForKey(dto.getOverTimeId());
		chkInsert(retDto);
		// コミット1
		commit();
		// モード設定
		vo.setMode(OverTimeAgreementCardVo.MODE_UPDATE);
		// メッセージ設定
		setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得		
		CmAgreementOverTimeDto dto = (CmAgreementOverTimeDto)getSessionDto();
		OverTimeAgreementCardVo vo = (OverTimeAgreementCardVo)getVo();
		vo.setParams(request);
		vo.setTxtOverTimeCode(dto.getOverTimeCode());
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// 限度基準コードの妥当性
		checkLimitStandard();
		// DAOの準備
		CmAgreementOverTimeDao dao = new CmAgreementOverTimeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		boolean comitFlag = true;
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getOverTimeId()));
		// 重複チェック
		if (MospConst.DELETE_FLAG_OFF == dto.getDeleteFlag()) {
			CmAgreementOverTimeDto overTimeDto = dao.findForStartDate(dto.getOverTimeCode(), dto.getStartDate());
			if (VariousUtil.isNotNull(overTimeDto) && (overTimeDto.getOverTimeId() != dto.getOverTimeId())) {
				addErrMessage(getMessage(MospConst.MSG_DUPLICATE, ""));
				comitFlag = false;
			}
		}
		if (comitFlag) {
			// データの更新
			dao.update(dto);
			// DTOの再取得
			CmAgreementOverTimeDto retDto = dao.findForKey(dto.getOverTimeId());
			chkUpdate(retDto);
			// コミット
			commit();
			// メッセージ設定
			setMessage(getMessage(MospConst.MSG_UPDATE, ""));
			// セッションにDTOをセット
			setSessionDto(retDto);
		}
		// モード設定
		vo.setMode(OverTimeAgreementCardVo.MODE_UPDATE);
	}
	
	/**
	 * 限度基準コード取得
	 * @return 限度基準コードリスト
	 * @throws SQLException SQL例外処理が発生した場合
	 * @throws NoSuchFieldException 指定された名前のフィールドがクラスにはない場合
	 * @throws IllegalAccessException 基本となるメソッドが例外をスローする場合
	 * @throws MospException  MosP例外処理が発生した場合
	 */
	protected String[][] getLimitStandardArray() throws SQLException, NoSuchFieldException, IllegalAccessException,
			MospException {
		// 情報の取得
		LaborAgreementManager laborAgreement = new LaborAgreementManager(cfg, cmd, aspUser, user, conn);
		// 配列の作成
		String[][] aryLimitStandard = laborAgreement.getLimitStandardArray();
		if (aryLimitStandard.length == 0) {
			addErrMessage(getMessage("WA1001", CommonConst.NAM_LIMIT_STANDARD));
		}
		return aryLimitStandard;
	}
	
	/**
	 * 限度基準コードの妥当性チェック
	 * @throws Exception 例外処理が発生した場合
	 */
	private void checkLimitStandard() throws Exception {
		/*
				OverTimeAgreementCardVo vo = (OverTimeAgreementCardVo)getVo();
				// 情報の取得
				LaborAgreement laborAgreement = new LaborAgreement(cfg, cmd, aspUser, user, conn);
				CmLimitStandardDto dto = laborAgreement.getLimitStandardInfo(vo.getPltLimitCode());
				// 育児又は家族介護のための時間外労働の制限
				final int limitHour = 150;
				if (VariousUtil.isNotNull(dto)) {
					String[][] aryAgreeType = part().mospcode().getAgreementTypeArray();
					if (vo.getPltAgreeType().equals(aryAgreeType[2][0]) && dto.getLimitYear() > limitHour) {
						addErrMessage(getMessage("WC2010", CommonConst.NAM_LIMIT_STANDARD));
						throw new MospException(MospConst.EX_DUPLICATE);
					}
				}
		*/
	}
	
}
